/// <reference types="node_modules/.pnpm/cropperjs@1.5.12/node_modules/cropperjs/types" />
import Cropper from 'cropperjs';
declare const _default: import("@vue/runtime-core").DefineComponent<{
    /** 设置图片上的alt属性 */
    alt: {
        type: StringConstructor;
        default: string;
    };
    /** 裁剪框的宽高比，默认 16/9 */
    aspectRatio: {
        type: NumberConstructor;
        default: number;
    };
    /** 初始化时，是否自动显示裁剪框，默认 true */
    autoCrop: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 定义自动裁剪面积大小（百分比） 默认0.8 */
    autoCropArea: {
        type: NumberConstructor;
        default: number;
    };
    /** 是否显示容器的网格背景 默认true */
    background: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 裁剪框是否在图片正中心,并显示一个 + 号 默认false */
    center: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 设置图片裁剪后返回的类型，可配置为 blob 和 base64  默认 base64 */
    cropType: {
        type: StringConstructor;
        default: string;
    };
    /** 设置裁剪弹框是否可见 默认false */
    cropvisible: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 定义 cropper 的拖拽模式，默认 crop ;'crop'： 可以产生一个新的裁剪框 3 。'move'：只可以移动图片 3 。'none'： 什么也不处理   */
    dragMode: {
        type: StringConstructor;
        default: string;
    };
    /** 是否在裁剪框上方显示虚线 默认true */
    guides: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 设置待裁剪图片的最大大小，默认为 1M */
    maxSize: {
        type: StringConstructor;
        default: string;
    };
    /** 容器的最小高度 默认 300 */
    minContainerHeight: {
        type: NumberConstructor;
        default: number;
    };
    /** 容器的最小宽度 默认 652 */
    minContainerWidth: {
        type: NumberConstructor;
        default: number;
    };
    /** 裁剪层的最小高度  默认0 */
    minCropBoxHeight: {
        type: NumberConstructor;
        default: number;
    };
    /** 裁剪层的最小宽度 默认0 */
    minCropBoxWidth: {
        type: NumberConstructor;
        default: number;
    };
    /** 是否显示图片上方裁剪框下方的黑色模态 默认true */
    modal: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否允许可以移动后面的图片 默认true */
    movable: {
        type: BooleanConstructor;
        default: boolean;
    };
    plugin: {
        type: (ObjectConstructor | FunctionConstructor)[];
        default: () => typeof Cropper;
    };
    /** 设置图片裁剪后的压缩比例，值在 0-1 之间 默认0.92 */
    quality: {
        type: NumberConstructor;
        default: number;
        validator: (value: number) => boolean;
    };
    /** 是否允许旋转图像;默认为 true */
    rotatable: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 默认裁剪的源图片 */
    src: {
        type: StringConstructor;
        default: string;
    };
    /** 定义 cropper 的视图模式,默认 0 ;0：没有限制，3 可以移动到 2 外。1：3 只能在 2 内移动。2：2 图片不全部铺满 1 （即缩小时可以有一边出现空隙）。3：2 图片填充整个 1 */
    viewMode: {
        type: NumberConstructor;
        default: number;
    };
    /** 用鼠标移动图像时，定义缩放比例 默认 0.1 */
    wheelZoomRatio: {
        type: NumberConstructor;
        default: number;
    };
    /** 是否可以通过滚动鼠标滚轮来缩放图像 默认true */
    zoomOnWheel: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否允许放大图像 默认true */
    zoomable: {
        type: BooleanConstructor;
        default: boolean;
    };
}, {
    t: (this: any, path: any, options?: any) => any;
    vm: any;
    f: (props: any, attrs?: {}) => {};
    a: (attrs: any, filters: any, include: any) => {};
    d: (props: any) => void;
    dp: (props: any) => void;
    gcls: (key: any) => any;
    m: (...cssClasses: any[]) => string;
}, unknown, {}, {}, import("@vue/runtime-core").ComponentOptionsMixin, import("@vue/runtime-core").ComponentOptionsMixin, ("ready" | "update:visible" | "update:cropvisible" | "cropdata" | "cropstart" | "cropmove" | "cropend" | "crop")[], "ready" | "update:visible" | "update:cropvisible" | "cropdata" | "cropstart" | "cropmove" | "cropend" | "crop", import("@vue/runtime-core").PublicProps, Readonly<import("@vue/runtime-core").ExtractPropTypes<{
    /** 设置图片上的alt属性 */
    alt: {
        type: StringConstructor;
        default: string;
    };
    /** 裁剪框的宽高比，默认 16/9 */
    aspectRatio: {
        type: NumberConstructor;
        default: number;
    };
    /** 初始化时，是否自动显示裁剪框，默认 true */
    autoCrop: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 定义自动裁剪面积大小（百分比） 默认0.8 */
    autoCropArea: {
        type: NumberConstructor;
        default: number;
    };
    /** 是否显示容器的网格背景 默认true */
    background: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 裁剪框是否在图片正中心,并显示一个 + 号 默认false */
    center: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 设置图片裁剪后返回的类型，可配置为 blob 和 base64  默认 base64 */
    cropType: {
        type: StringConstructor;
        default: string;
    };
    /** 设置裁剪弹框是否可见 默认false */
    cropvisible: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 定义 cropper 的拖拽模式，默认 crop ;'crop'： 可以产生一个新的裁剪框 3 。'move'：只可以移动图片 3 。'none'： 什么也不处理   */
    dragMode: {
        type: StringConstructor;
        default: string;
    };
    /** 是否在裁剪框上方显示虚线 默认true */
    guides: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 设置待裁剪图片的最大大小，默认为 1M */
    maxSize: {
        type: StringConstructor;
        default: string;
    };
    /** 容器的最小高度 默认 300 */
    minContainerHeight: {
        type: NumberConstructor;
        default: number;
    };
    /** 容器的最小宽度 默认 652 */
    minContainerWidth: {
        type: NumberConstructor;
        default: number;
    };
    /** 裁剪层的最小高度  默认0 */
    minCropBoxHeight: {
        type: NumberConstructor;
        default: number;
    };
    /** 裁剪层的最小宽度 默认0 */
    minCropBoxWidth: {
        type: NumberConstructor;
        default: number;
    };
    /** 是否显示图片上方裁剪框下方的黑色模态 默认true */
    modal: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否允许可以移动后面的图片 默认true */
    movable: {
        type: BooleanConstructor;
        default: boolean;
    };
    plugin: {
        type: (ObjectConstructor | FunctionConstructor)[];
        default: () => typeof Cropper;
    };
    /** 设置图片裁剪后的压缩比例，值在 0-1 之间 默认0.92 */
    quality: {
        type: NumberConstructor;
        default: number;
        validator: (value: number) => boolean;
    };
    /** 是否允许旋转图像;默认为 true */
    rotatable: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 默认裁剪的源图片 */
    src: {
        type: StringConstructor;
        default: string;
    };
    /** 定义 cropper 的视图模式,默认 0 ;0：没有限制，3 可以移动到 2 外。1：3 只能在 2 内移动。2：2 图片不全部铺满 1 （即缩小时可以有一边出现空隙）。3：2 图片填充整个 1 */
    viewMode: {
        type: NumberConstructor;
        default: number;
    };
    /** 用鼠标移动图像时，定义缩放比例 默认 0.1 */
    wheelZoomRatio: {
        type: NumberConstructor;
        default: number;
    };
    /** 是否可以通过滚动鼠标滚轮来缩放图像 默认true */
    zoomOnWheel: {
        type: BooleanConstructor;
        default: boolean;
    };
    /** 是否允许放大图像 默认true */
    zoomable: {
        type: BooleanConstructor;
        default: boolean;
    };
}>> & {
    "onUpdate:visible"?: ((...args: any[]) => any) | undefined;
    onReady?: ((...args: any[]) => any) | undefined;
    onCrop?: ((...args: any[]) => any) | undefined;
    "onUpdate:cropvisible"?: ((...args: any[]) => any) | undefined;
    onCropdata?: ((...args: any[]) => any) | undefined;
    onCropstart?: ((...args: any[]) => any) | undefined;
    onCropmove?: ((...args: any[]) => any) | undefined;
    onCropend?: ((...args: any[]) => any) | undefined;
}, {
    src: string;
    center: boolean;
    plugin: Function | Record<string, any>;
    background: boolean;
    aspectRatio: number;
    modal: boolean;
    alt: string;
    autoCrop: boolean;
    autoCropArea: number;
    cropType: string;
    cropvisible: boolean;
    dragMode: string;
    guides: boolean;
    maxSize: string;
    minContainerHeight: number;
    minContainerWidth: number;
    minCropBoxHeight: number;
    minCropBoxWidth: number;
    movable: boolean;
    quality: number;
    rotatable: boolean;
    viewMode: number;
    wheelZoomRatio: number;
    zoomOnWheel: boolean;
    zoomable: boolean;
}, {}>;
export default _default;
